﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;

namespace WindowsFormsApplication45
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private Bitmap GetBitmap(Color color)
        {
            Bitmap bmp = new Bitmap(32, 32);
            using (Graphics g = Graphics.FromImage(bmp))
            {
                g.Clear(Color.Transparent);
                using (Brush b = new SolidBrush(color))
                    g.FillEllipse(b, new Rectangle(0, 0, 31, 31));
            }

            return bmp;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            UltraGridLayout layout = e.Layout;
            UltraGridBand band = layout.Bands[0];
            UltraGridColumn column = band.Columns[0];

            // Don't let the user type into the cell, make them select from the list. 
            column.Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownList;

            // Align the image in the cell to the center.
            column.CellAppearance.ImageHAlign = HAlign.Center;

            // Since the image is aligned to the center, always show the dropdown button. Otherwise, the dropdown
            // button will onl show when the mouse is over the cell and this causes the image to shift. 
            column.ButtonDisplayStyle = Infragistics.Win.UltraWinGrid.ButtonDisplayStyle.Always;

            // Create a ValueList. 
            ValueList vl = layout.ValueLists.Add("MyValueList");

            // Align the images on the ValueList to the center. 
            vl.Appearance.ImageHAlign = HAlign.Center;

            // Add some items with images.
            ValueListItem vli = vl.ValueListItems.Add(1, "Red");
            vli.Appearance.Image = this.GetBitmap(Color.Red);
            vli = vl.ValueListItems.Add(2, "Yellow");
            vli.Appearance.Image = this.GetBitmap(Color.Yellow);
            vli = vl.ValueListItems.Add(3, "Green");
            vli.Appearance.Image = this.GetBitmap(Color.Green);
            
            // Only display images (no text) on the ValueList. 
            vl.DisplayStyle = ValueListDisplayStyle.Picture;

            // Attach the ValueList to the grid column.
            column.ValueList = vl;

            // Set the default height of the rows in the grid to the height of the images. 
            // Otherwise, the images get scaled down. 
            layout.Override.DefaultRowHeight = 32;
        }
    }
}
